

function love.load()

	--Initilize tap variable to hold touch ids
	taps = nil

	--Initiate beenThereFor variable
	beenThereFor = 0

	--Initilize game state variables
	menu = true
	game = false
	finalScore = false

	--Initilize Boxes array variable
	Boxes = {}

	--Preparing BG variable
	width, height = love.graphics.getDimensions()
	BG = {x = 0, y = 0, width = width, height = height}

	--Importing game assets
	tapBoxImg = love.graphics.newImage('assets/TapBox.png')
	titleFont1 = love.graphics.newFont('assets/titleFont_8-bit.ttf', 125)
	titleFont2 = love.graphics.newFont('assets/titleFont_8-bit.ttf', 55)

	--Score
	score = 0

	--Timers
	createBoxTimerMax = 1.0
	createBoxTimer = createBoxTimerMax

end

function love.update(dt)

	--Update taps variable
	taps = love.touch.getTouches()
	
	--Menu Game state
	if menu == true then
		--Check if play Button is Tapped
		for i, tap in ipairs(taps) do
			local x, y = love.touch.getPosition(tap)
			if x >= BG.width/2-55 and
			x <= BG.width/2+55 and
			y >= BG.height/2 and
			y <= BG.height/2+42 then
				menu = false
				game = true
			end
		end
		--Check if quit Button is Tapped
		for i, tap in ipairs(taps) do
			local x, y = love.touch.getPosition(tap)
			if x >= BG.width/2-52 and
			x <= BG.width/2+52 and
			y >= BG.height/2+90 and
			y <= BG.height/2+132 then
				love.event.quit()
			end
		end
	end
	--Game game state
	if game == true then

		--Deacreas createBoxTimerMax
		createBoxTimerMax = createBoxTimerMax - 0.0003

		--Check length of 'Boxes'
		looped = 0
		for i in ipairs(Boxes) do
			looped = looped + 1
		end
		--Check if game is over
		if looped >= 10 then
			game = false
			finalScore = true
			Boxes = {}
			createBoxTimer = createBoxTimerMax
		end
		-- Time out Box creation
		createBoxTimer = createBoxTimer - (1 * dt)
		if createBoxTimer < 0 then
			createBoxTimer = createBoxTimerMax
			-- Create a box
			randomNumberX = math.random(0, BG.width-50)
			randomNumberY = math.random(0, BG.height-50)
			newBox = { x = randomNumberX, y = randomNumberY, img = TapBoxImg }
			table.insert(Boxes, newBox)
		end
		--Make boxes wiggle if the user is close to losing
		if looped >= 7 then
			for i, box in ipairs(Boxes) do
				wiggleDirection = math.random(0, 1)
				if wiggleDirection  == 0 then
					wiggleX = math.random(box.x - 2, box.x + 2)
					box.x = wiggleX
				else
					wiggleY = math.random(box.y - 2, box.y + 2)
					box.y = wiggleY
				end
			end
		end
		--Check if any boxes are clicked
		for i, box in ipairs(Boxes) do
			for i, tap in ipairs(taps) do
				local x, y = love.touch.getPosition(tap)
				if x >= box.x and
				x <= box.x+50 and
				y >= box.y and
				y <= box.y+50 then
					table.remove(Boxes, i)
					score = score + 1
				end
			end
		end
	end
	--finalScore game state
	if finalScore == true then
		beenThereFor = beenThereFor + 1 * dt
		looped = 0
		for i in ipairs(taps) do
			looped = looped + 1
		end
		if looped > 0 and
		beenThereFor > 1 then
			finalScore = false
			game = true
			score = 0
			createBoxTimerMax = 1.0
			looped = 0
		end
	end
end

function love.draw(dt)

	--Draw the BG
	if menu == true then
		love.graphics.setColor( 80, 148, 160 )
		love.graphics.rectangle("fill", BG.x, BG.y, BG.width, BG.height)
	end
	if game == true then
		love.graphics.setColor( 50, 195, 219 )
		love.graphics.rectangle("fill", BG.x, BG.y, BG.width, BG.height)
	end
	if finalScore == true then
		love.graphics.setColor( 50, 195, 219 )
		love.graphics.rectangle("fill", BG.x, BG.y, BG.width, BG.height)
	end
	--Draw menu game state
	if menu == true then
		love.graphics.setColor(255, 255, 255)
		love.graphics.setFont(titleFont2)
		love.graphics.print("Play", BG.width/2-55, BG.height/2)
		love.graphics.print("Quit", BG.width/2-52, BG.height/2+90)
		love.graphics.setFont(titleFont1)
		love.graphics.print("Tap Box", BG.width/2-258, 20)
	--Draw Game game state
	elseif game == true then
		for i, box in ipairs(Boxes) do
			love.graphics.draw(tapBoxImg, box.x, box.y)
		end
		love.graphics.setFont(titleFont2)
		love.graphics.setColor(255, 255, 255)
		love.graphics.print('Score: ' .. tostring(score))
	--Draw finalScore game state
	elseif finalScore == true then
		love.graphics.setColor(255, 255, 255)
		love.graphics.setFont(titleFont1)
		love.graphics.print('Game\nOver', BG.width/2-150, 55)
		love.graphics.setFont(titleFont2)
		love.graphics.print('You score was: ' .. tostring(score) .. "\n(Tap to restart)", BG.width/2-170, 300)
	end
end